/*
 *  CSS Gradient Generator
 *  v2.2.1
 *  CSS gradient generator with the best browser support. Three different layouts to meet Your requirement (from simple linear to complex radial gradients).
 *  https://www.virtuosoft.eu/tools/css-gradient-generator/
 *
 *  Made by Virtuosoft:
 *      István Ujj-Mészáros - https://github.com/istvan-ujjmeszaros
 *      Ferenc Fapál - http://twitter.com/fwoodpaul
 *
 *  Thanks for the following persons:
 *      Tibor Szász - https://github.com/kowdermeister
 *      László Sotus - https://github.com/Lacisan
 *
 *  Under CC BY-NC-SA 4.0 License
 *  To view a copy of this license, visit
 *  http://creativecommons.org/licenses/by-nc-sa/4.0/deed.en_US.
 */

var CSSGradientEditor=function(s,t){"use strict";"undefined"!=typeof console&&void 0!==console.log||(console={log:function(){}});var i,o,e,n,a,r=0,l=1,c=2,d=-3e3,p=3e3,g=100,u=null,f=0,h=[],v=[],_=-1,m=!1,w="#c30000",b="%",x=0,k=!1,y=!1,z=!1,C=!1,S=!1,M=!1,j=!1,P=!1,D=!1,R=!1,I=-1,T=[],O="",A=!1,H=!1,E={noprefix:!1,svg:!1,oldwebkit:!1,filter:!1},G=!1,U={hue:0,saturation:0,lightness:0},N={markersarea:$(".css-gradient-editor-stoppointmarkers",s),gradientstopeditor:$(".css-gradient-editor-stopeditor span",s),anglecontroller:$(".css-gradient-editor-controller.css-gradient-editor-direction-angle",s),angleline:$(".css-gradient-editor-controller.css-gradient-editor-direction-angle span",s),angleinput:$("span.css-gradient-editor-direction-angle-input input",s),previewcontainer:$(".css-gradient-editor-preview-container",s),previewarea:$(".css-gradient-editor-preview",s),preview:$(".css-gradient-editor-preview div",s),previewpopoutbutton:$(".css-gradient-editor-previewpopout",s),previewpopoutoverlaybutton:$(".css-gradient-controls .css-gradient-editor-previewpopout",s),colorstopslist:$(".css-gradient-editor-stoppointlist",s),cssoutput:$(".css-gradient-editor-cssoutput",s),exportallmodal:$("#exportallmodal"),exportalltextarea:$(".css-gradient-editor-textarea-exportall"),importmodal:$("#importmodal"),configmodal:$("#configmodal"),importtextarea:$(".css-gradient-editor-textarea-import"),permalink:$(".css-gradient-editor-permalink",s),imagegradient:$(".css-gradient-editor-imagegradient",s),currentpreset:$(".css-gradient-editor-preset.current span",s),actualswatch:!1,swatchescontainer:$(".css-gradient-editor-swatches",s),swatches:$(".css-gradient-editor-swatches ul",s),swatches_add:$(".css-gradient-editor-save",s),swatches_remove:$(".css-gradient-editor-delete",s),resizehandler:$(".css-gradient-editor-preview-resize-handler",s),adjust_color:$(".css-gradient-editor-adjustcolor",s),get_css:$(".css-gradient-editor-getcss",s),coloroffsethue:!1,coloroffsetchroma:!1,colorofsetlightness:!1,undobutton:$(".css-gradient-editor-undo",s),redobutton:$(".css-gradient-editor-redo",s),addstoppointbutton:$(".css-gradient-editor-add-stoppoint",s),reorderstoppointsbutton:$(".css-gradient-editor-reorder-stoppoints",s),gradientpreferenceseasy:$(".gradient-preferences-easy",s),gradientpreferencesadvanced:$(".gradient-preferences-advanced",s),inputfrom:$("input[name=color_from]",s),inputto:$("input[name=color_to]",s),layoutselectoreasy:$(".css-gradient-editor-layout-easy"),layoutselectoradvanced:$(".css-gradient-editor-layout-advanced"),layoutselectorexpert:$(".css-gradient-editor-layout-expert"),warningadvanced:$(".layout-warning-advanced"),warningexpert:$(".layout-warning-expert"),loaddefaults:$(".loaddefaults","#importmodal"),gradientpropertiespanel:$(".panel.gradient-properties",s)},X=$.extend({customswatchesnameprefix:"cssgradienteditor",defaultswatches:["t=linear,d=bottom+right,r=on|00c4f4/0/%,036078/100/%","t=linear,d=bottom+right,r=on|fe9e96/0/%,ac4f73/100/%","t=radial,s=farthest-corner,r=off,sh=ellipse,h=left,v=top|676767/1.1/%,878787/65.8/%,676767/100/%","t=linear,d=bottom+right,r=off|f949b6/0/%,ff8b8b/100/%","t=radial,s=farthest-corner,r=on,sh=ellipse,h=left,v=bottom|f3ef15/0/%,009885/100/%","t=linear,d=bottom,r=on|e2e2e2/0/%,dbdbdb/50/%,d1d1d1/51/%,fefefe/100/%","t=linear,d=bottom,r=on|accdd4/0/%,189ab1/50/%,087b95/51/%,70c0d1/100/%","t=linear,d=bottom,r=on|48556c/0/%,1b212b/50/%,141922/51/%,353b45/100/%","t=linear,d=bottom,r=on|808080/0/%,5b5b5b/65.6/%,a9a9a9/100/%","t=linear,d=bottom+right,r=on|000000/0/%,ffffff/100/%","t=linear,d=bottom+right,r=on|000000/0/%,00000000/100/%","t=radial,s=farthest-side,r=off,sh=circle,h=explicit,hv=395,hu=px,v=explicit,vv=483,vu=px|2200cf/0/%,ac00d7/74.2/%,8206ff/83.3/%","t=radial,s=explicit,sv=531,su=px,r=off,sh=circle,h=explicit,hv=59,hu=px,v=explicit,vv=147,vu=px|ffffff/0/%,e544c6/70/%,047694/100/%","t=radial,s=farthest-side,r=off,sh=ellipse,h=center,v=center|535b5e/0/%,fefefe/25/%,4a5154/50/%,fdfdfd/75/%,535b5e/100/%","t=linear,d=bottom+right,r=on|00a5df/0/%,3e147b/20/%,e20079/40/%,df132c/60/%,f3ef15/80/%,009847/100/%","t=linear,d=bottom+right,r=on|00a5df/0/%,3e147b/6.6/%,e20079/13.2/%,df132c/18.8/%,f3ef15/24.1/%,009847/26.6/%","t=linear,d=bottom+right,r=on|535b5e/0/%,fefefe/25/%,4a5154/50/%,fdfdfd/75/%,535b5e/100/%","t=linear,d=bottom+right,r=on|000000/0/%,000000/9/%,00000000/10/%,00000000/19/%,000000/20/%,000000/29/%,00000000/30/%,00000000/39/%,000000/40/%,000000/49/%,00000000/50/%,00000000/59/%,000000/60/%,000000/69/%,00000000/70/%,00000000/79/%,000000/80/%,000000/89/%,00000000/90/%,00000000/100/%","t=linear,d=bottom+right,r=on|000000/0/%,000000/9/%,252525/9.1/%,252525/18/%,464646/18.1/%,464646/27/%,636363/27.1/%,636363/36/%,7d7d7d/36.1/%,7d7d7d/45/%,959595/45.1/%,959595/54/%,acacac/54.1/%,acacac/63/%,c2c2c2/63.1/%,c2c2c2/72/%,d7d7d7/72.1/%,d7d7d7/81/%,ebebeb/81.1/%,ebebeb/90/%,ffffff/90.1/%,ffffff/100/%","t=radial,s=explicit,sv=10,su=em,r=on,sh=circle,h=left,v=top|accdd4/0/%,189ab1/50/%,087b95/51/%,70c0d1/100/%","t=linear,d=angle,r=off,a=248|0001cdca/13.4/%,01cdca/14.5/%,015f9e/19.3/%,0001cdca/20.5/%"],remove_distance:50,positiondecimals:1,gradient_type:"linear",gradient_direction:"bottom right",gradient_size:"farthest-corner",gradient_size_value:"10",gradient_size_unit:"px",gradient_size_major_value:"10",gradient_size_major_unit:"px",gradient_repeat:"off",gradient_shape:"ellipse",linear_gradient_angle:"0",gradient_position_horizontal:"left",gradient_position_horizontal_value:"0",gradient_position_horizontal_unit:"%",gradient_position_vertical:"top",gradient_position_vertical_value:"0",gradient_position_vertical_unit:"%"},t),Y={gradient_type:"t",gradient_direction:"d",gradient_size:"s",gradient_size_value:"sv",gradient_size_unit:"su",gradient_size_major_value:"smv",gradient_size_major_unit:"smu",gradient_repeat:"r",gradient_shape:"sh",linear_gradient_angle:"a",gradient_position_horizontal:"h",gradient_position_horizontal_value:"hv",gradient_position_horizontal_unit:"hu",gradient_position_vertical:"v",gradient_position_vertical_value:"vv",gradient_position_vertical_unit:"vu"},F={config_layout:l,config_colorformat:"rgb",config_colorpicker_hsl:!0,config_colorpicker_rgb:!0,config_colorpicker_cie:!1,config_colorpicker_opacity:!0,config_colorpicker_swatches:!1,config_fallbackwidth:"",config_fallbackheight:"",config_mixedstoppointunits:"enabled",config_generation_bgcolor:!0,config_generation_iefilter:!0,config_generation_svg:!0,config_generation_oldwebkit:!0,config_generation_webkit:!0,config_generation_ms:!0,config_cssselector:".gradient"};function q(){return E.css?"filter"===E.css&&E.svg?"svg":E.css:E.svg?"svg":"averagebgcolor"}function J(t){var e=t.attr("name");Mt(e+"_value",t.val()),Mt(e+"_unit",t.next(".bootstrap-touchspin-postfix").text())}function L(){var t=function(t){var e={advanced:!1,expert:!1},o=Ht(t);2===o.length&&"0"===o[0].position&&"100"===o[1].position&&"%"===o[0].unit&&"%"===o[1].unit||(e.advanced=!0);"on"===St("gradient_repeat",t)&&(e.advanced=!0);switch(St("gradient_type",t)){case"linear":var i=St("gradient_direction",t);"angle"===i&&(e.expert=!0),"top left"!==i&&"top right"!==i&&"bottom left"!==i&&"bottom right"!==i||(e.advanced=!0);break;case"radial":e.advanced=!0,"circle"===St("gradient_shape",t)&&(e.expert=!0),"explicit"===St("gradient_size",t)&&(e.expert=!0),"explicit"===St("gradient_position_horizontal",t)&&(e.expert=!0),"explicit"===St("gradient_position_vertical",t)&&(e.expert=!0)}if(e.expert)return c;if(e.advanced)return l;return r}(tt(o));switch(a=le("config_layout"),N.layoutselectoreasy.removeClass("active"),N.layoutselectoradvanced.removeClass("active"),N.layoutselectorexpert.removeClass("active"),a){case r:N.layoutselectoreasy.addClass("active");break;case l:N.layoutselectoradvanced.addClass("active");break;case c:N.layoutselectorexpert.addClass("active")}H=!1,a<t?(H=!0,t===l?N.warningadvanced.is(":visible")||(N.warningexpert.hide(),N.warningadvanced.show()):N.warningexpert.is(":visible")||(N.warningadvanced.hide(),N.warningexpert.show()),a=t):(N.warningadvanced.is(":visible")&&N.warningadvanced.hide(),N.warningexpert.is(":visible")&&N.warningexpert.hide());var e=!1;switch(a){case r:s.hasClass("layout-simple")||(e=!0,s.removeClass("layout-advanced layout-expert"),s.addClass("layout-simple"));break;case l:s.hasClass("layout-advanced")||(e=!0,s.removeClass("layout-simple layout-expert"),s.addClass("layout-advanced"));break;case c:s.hasClass("layout-expert")||(e=!0,s.removeClass("layout-simple layout-advanced"),s.addClass("layout-expert"))}e&&mt()}function Q(){$('input[name="gradient_size"]').val(St("gradient_size_value")),$('input[name="gradient_size_major"]').val(St("gradient_size_major_value")),$('input[name="gradient_position_horizontal"]').val(St("gradient_position_horizontal_value")),$('input[name="gradient_position_vertical"]').val(St("gradient_position_vertical_value")),ct($('input[name="gradient_size"]').next(".input-group-addon.bootstrap-touchspin-postfix"),St("gradient_size_unit")),ct($('input[name="gradient_size_major"]').next(".input-group-addon.bootstrap-touchspin-postfix"),St("gradient_size_major_unit")),ct($('input[name="gradient_position_horizontal"]').next(".input-group-addon.bootstrap-touchspin-postfix"),St("gradient_position_horizontal_unit")),ct($('input[name="gradient_position_vertical"]').next(".input-group-addon.bootstrap-touchspin-postfix"),St("gradient_position_vertical_unit"))}function B(){if(U={hue:0,saturation:0,lightness:0},0!==h.length&&void 0!==h[0].originalcolor){N.hueoffset&&(N.hueoffset.val(0),N.saturationoffset.val(0),N.lightnessoffset.val(0));for(var t=0;t<h.length;t++)delete h[t].originalcolor;N.coloroffsethue.css("left","50%"),N.coloroffsetchroma.css("left","50%"),N.coloroffsetlightness.css("left","50%")}}function W(){for(var t=0;t<h.length;t++){var e,o,i=h[t];i.originalcolor,e=(o=i.originalcolor?tinycolor(i.originalcolor):(i.originalcolor=i.color,tinycolor(i.color))).toHsl(),(o=$.fn.ColorPickerSliders.rgb2lch(o.toRgb())).h+=U.hue,o.h=Math.abs(o.h+360)%360,o.c+=1.44*U.saturation,o.l+=1.01*U.lightness,o.c<0&&(o.c=0),o.l<0&&(o.l=0),e.h+=U.hue,e.h=Math.abs(e.h+360)%360,e.s+=U.saturation/100,e.l+=U.lightness/100,1<e.s&&(e.s=1),e.s<0&&(e.s=0),1<e.l&&(e.l=1),e.l<0&&(e.l=0),i.color=tinycolor($.fn.ColorPickerSliders.lch2rgb(o)).toRgbString()}}function K(t){var e=t.hasOwnProperty("color")?t.color:t;switch(le("config_colorformat")){case"hsl":return tinycolor(e).toHslString();case"hex":return tinycolor(e).getAlpha()<1?tinycolor(e).toRgbString():tinycolor(e).toHexString();default:return e}}function V(t,e,o){return o.replace(new RegExp(t,"g"),e)}function Z(e){var o;try{o=decodeURIComponent(e)}catch(t){o=e}return o.replace("+"," ")}function tt(t){if(!((t=(t=ie(t)).split("&sp="))instanceof Array))return!1;if(2!==t.length)return!1;for(var e={},o=[],i=t[0].split("&"),n=t[1].split("__"),a=0;a<i.length;a++)e[function(t){for(var e in Y)if(Y[e]===t)return e}((t=i[a].split("="))[0])]=Z(t[1]);for(a=0;a<n.length;a++)(t=n[a].split("_"))[0].length&&o.push({color:tinycolor(Z(t[0])).toRgbString(),position:Z(t[1]),unit:Z(t[2]),index:a,markforDeath:!1});return{data:e,colorStops:o}}function et(t){var e,o={},i="";try{i=(o=(e=tt(void 0===t?window.location.search.substring(1):t)).data,e.colorStops)}catch(t){}if(s.data({gradient_type:(o=void 0===o?{}:o).gradient_type||X.gradient_type,gradient_direction:o.gradient_direction||X.gradient_direction,gradient_size:o.gradient_size||X.gradient_size,gradient_size_value:o.gradient_size_value||X.gradient_size_value,gradient_size_unit:o.gradient_size_unit||X.gradient_size_unit,gradient_size_major_value:o.gradient_size_major_value||X.gradient_size_major_value,gradient_size_major_unit:o.gradient_size_major_unit||X.gradient_size_major_unit,gradient_repeat:o.gradient_repeat||X.gradient_repeat,gradient_shape:o.gradient_shape||X.gradient_shape,linear_gradient_angle:o.linear_gradient_angle||X.linear_gradient_angle,gradient_position_horizontal:o.gradient_position_horizontal||X.gradient_position_horizontal,gradient_position_horizontal_value:o.gradient_position_horizontal_value||X.gradient_position_horizontal_value,gradient_position_horizontal_unit:o.gradient_position_horizontal_unit||X.gradient_position_horizontal_unit,gradient_position_vertical:o.gradient_position_vertical||X.gradient_position_vertical,gradient_position_vertical_value:o.gradient_position_vertical_value||X.gradient_position_vertical_value,gradient_position_vertical_unit:o.gradient_position_vertical_unit||X.gradient_position_vertical_unit}),ot(),void 0!==i&&""!==i)for(var n=0;n<i.length;n++)_t(i[n])}function ot(){$(".css-gradient-editor-controller").each(function(){var t=$(this);0!==t.data("name").indexOf("config_")&&(s.data(t.data("name"))===t.data("value")?(t.addClass("active"),t.trigger("mousedown")):t.removeClass("active"))})}function it(){try{N.adjust_color.popover("destroy"),i.remove()}catch(t){}M=!1}function nt(){return N.previewpopoutbutton.hasClass("active")}function at(){var t,e,o,i,n;D||(t=!0,i=N.previewcontainer.offset(),o=N.gradientpropertiespanel.offset(),n=$(window).height(),(e=N.gradientpropertiespanel.height()+o.top)-i.top<n&&(t=!1),i=(o=$(document).scrollTop())-i.top,e<o+(n=Math.round(n/3))&&(t=!1),!(t=i<0?!1:t)||N.previewarea.hasClass("preview-sticky")&&!P?!t&&N.previewarea.hasClass("preview-sticky")&&!1!==j&&(N.previewarea.removeClass("preview-sticky"),N.previewarea.css("top",0),N.resizehandler.show(),N.previewcontainer.height("auto"),N.previewarea.height(j),j=!1,("oldwebkit"===q()||"svg"===q()&&"explicit"===St("gradient_size")&&"%"!==St("gradient_size_unit"))&&mt()):(!1===j&&(j=N.previewarea.height(),N.previewcontainer.height(N.previewarea.height()),N.previewarea.addClass("preview-sticky"),N.resizehandler.hide(),n<j&&N.previewarea.height(n),(P||N.previewarea.offset().top<o)&&(P=!0,N.previewarea.addClass("buggyfixed")),("oldwebkit"===q()||"svg"===q()&&"explicit"===St("gradient_size")&&"%"!==St("gradient_size_unit"))&&mt()),P&&N.previewarea.css("top",i)))}function rt(){var t,e,o,i;N.previewpopoutbutton.hasClass("active")?(t=$(window).width(),e=$(window).height(),o=le("popoutpreviewwidth"),e<(i=void 0===(i=le("popoutpreviewheight"))?100:i)&&(i=e),N.previewarea.width((o=t<(o=void 0===o?100:o)?t:o)+"px"),N.previewarea.height(i+"px")):(N.previewarea.width(le("previewwidth")||"100%"),N.previewarea.height(le("previewheight")||"197px"),N.previewpopoutoverlaybutton.hide())}function st(t,e){void 0===e&&(e=!0),N.preview.addClass("ajax-loader"),setTimeout(function(){A=!1,B(),wt(),et(t),Q(),ot(),setTimeout(function(){mt(e),N.preview.removeClass("ajax-loader")},100),ae(),Pt(),Bt(),L()},100)}function lt(t,e,o){var i;if(!1===t)for(i=0;i<h.length;i++)h[i][e]=o;else for(i=0;i<h.length;i++)if(h[i].index===t){h[i][e]=o;break}}function ct(t,e){var o=t.html(),i=t.prev("input"),n=i.data("units");if(void 0===e){if(e="",void 0===n)return;o=n.indexOf(o);e=n.length>o+1?n[o+1]:n[0]}t.html(e),J(i)}function dt(t){void 0===t&&(t=!1);var e=St("gradient_type");"linear"===e?($(".css-gradient-editor-linear-preferences",s).show(),$(".css-gradient-editor-radial-preferences",s).hide(),t&&$("[data-name=gradient_type][data-value=linear]").trigger("mousedown")):"radial"===e&&($(".css-gradient-editor-linear-preferences",s).hide(),$(".css-gradient-editor-radial-preferences",s).show(),t&&$("[data-name=gradient_type][data-value=radial]").trigger("mousedown"),"circle"===St("gradient_shape")?$("input[name=gradient_size_major]").parent().hide():$("input[name=gradient_size_major]").parent().show()),gt()}function pt(t){var e=ht(t),o=N.anglecontroller.offset(),i=N.anglecontroller.width(),t=N.anglecontroller.height();!1!==e?(i=Math.round(e.pageX-o.left-i/2),t=Math.round(e.pageY-o.top-t/2),Mt("linear_gradient_angle",Math.round((i=i,90+(0<=(t=t)?180*Math.atan2(t,i)/Math.PI:360+180*Math.atan2(t,i)/Math.PI)))%360)):R=!1}function gt(t){var e=St("linear_gradient_angle");void 0===t&&(t=!0),N.angleline.css("-webkit-transform","rotate("+e+"deg)"),N.angleline.css("-ms-transform","rotate("+e+"deg)"),N.angleline.css("transform","rotate("+e+"deg)"),t&&N.angleinput.val(e)}function ut(t){void 0===t&&(t=!0),$(".color-stop, .css-gradient-editor-stoppointdata").each(function(){var t=$(this);t.data("index")===I?(t.addClass("selected"),w=t.data("color")):t.removeClass("selected")}),t&&$("input.css-gradient-editor-stop-point-color",N.colorstopslist).blur()}function ft(t){I=t}function ht(t){return void 0!==t.pageX?{pageX:t.pageX,pageY:t.pageY}:void 0!==t.originalEvent&&void 0!==t.originalEvent.touches&&{pageX:t.originalEvent.touches[0].pageX,pageY:t.originalEvent.touches[0].pageY}}function vt(t,e){var o=ht(t),i=e.width(),n=o.pageX-e.offset().left,t=e.height(),e=o.pageY-e.offset().top,i=n/i*100,t=e/t*100;return{horizontal:{percent:i=100<(i=i<0?0:i)?100:i,pixel:n},vertical:{percent:t=100<(t=t<0?0:t)?100:t,pixel:e}}}function _t(t){t={index:x++,position:t.position,unit:t.unit||b,color:t.color,markForDeath:!1};b=t.unit,h.push(t),ft(t.index)}function mt(t){var e,o;void 0===t&&(t=!1),Zt(),yt(),$("input.css-gradient-editor-stop-point-color",N.colorstopslist).each(function(){$(this).trigger("colorpickersliders.hide")}),N.addstoppointbutton.hide(),N.colorstopslist.addClass("ajax-loader"),r<a||(e=xt(),$(".cp-container",N.gradientpreferenceseasy).remove(),0<(o=Ht()).length&&N.inputfrom.val(o[0].color),1<o.length&&N.inputto.val(o[1].color),N.inputfrom.ColorPickerSliders({flat:!0,order:e.sliders,swatches:e.swatches,previewformat:e.previewformat,onchange:function(t,e){z||C||S||B(),lt(0,"color",e.tiny.toRgbString()),w=e.tiny.toRgbString(),Zt()}}),N.inputto.ColorPickerSliders({flat:!0,order:e.sliders,swatches:e.swatches,previewformat:e.previewformat,onchange:function(t,e){z||C||S||B(),lt(1,"color",e.tiny.toRgbString()),w=e.tiny.toRgbString(),Zt()}})),setTimeout(function(){$t(),N.colorstopslist.removeClass("ajax-loader"),t&&pe(),A=!0},20)}function wt(){h=[],x=0,ft(-1)}function bt(t){for(var e=0;e<h.length;e++)if(h[e].index===t){h.splice(e,1),$("input.css-gradient-editor-stop-point-color",N.colorstopslist).trigger("colorpickersliders.hide");break}Zt(),yt(),$t()}function xt(){var t={},e=0,o=le("config_colorpicker_swatches"),i=le("config_colorformat")||"rgb";return le("config_colorpicker_hsl")&&(t.hsl=e++),le("config_colorpicker_rgb")&&(t.rgb=e++),le("config_colorpicker_cie")&&(t.cie=e++),le("config_colorpicker_opacity")&&(t.opacity=e+1),0!==e||o||(t.hsl=0),{swatches:o,sliders:t,previewformat:i}}function kt(){var t=Ht();N.inputfrom.trigger("colorpickersliders.updateColor",t[0].color),N.inputto.trigger("colorpickersliders.updateColor",t[1].color)}function $t(){if(a!==r){Dt(),N.colorstopslist.empty(),N.addstoppointbutton.show(),N.reorderstoppointsbutton.prop("disabled",!0);for(var t=0;t<h.length;t++){var e=h[t],o=$('<div class="css-gradient-editor-stoppointdata clearfix"></div>');o.appendTo(N.colorstopslist),$('<button type="button" class="btn btn-sm pull-right css-gradient-editor-stop-point-delete"><span class="pngicon-remove2"></span></button><input class="css-gradient-editor-stop-point-color input-sm" type="text" value="'+K(e)+'"> <input class="css-gradient-editor-stop-point-position input-sm" type="text" value="'+e.position+'">').appendTo(o),o.data(e),$("input.css-gradient-editor-stop-point-position",o).TouchSpin({min:d,max:p,postfix:e.unit,decimals:X.positiondecimals,step:Math.pow(.1,X.positiondecimals)})}$(".css-gradient-editor-stop-point-delete",N.colorstopslist).on("click",function(){bt($(this).closest(".css-gradient-editor-stoppointdata").data("index"))}),$("input.css-gradient-editor-stop-point-position",N.colorstopslist).on("change",function(){var t=$(this),e=t.closest(".css-gradient-editor-stoppointdata").data("index");lt(e,"position",t.val()),ft(e),yt(),ut(),Zt()}).on("touchspin.on.stopspin",function(){pe(),Rt(!1)});var i=xt();$("input.css-gradient-editor-stop-point-color",N.colorstopslist).ColorPickerSliders({flat:!1,placement:"bottom",order:i.sliders,swatches:i.swatches,previewformat:i.previewformat,onchange:function(t,e){B(),it(),lt($(this)[0].connectedinput.closest(".css-gradient-editor-stoppointdata").data("index"),"color",e.tiny.toRgbString()),w=e.tiny.toRgbString(),yt(),Zt()}}),$("input",N.colorstopslist).focus(function(){ft($(this).closest(".css-gradient-editor-stoppointdata").data("index")),ut(!1)})}}function yt(){if(a!==r){Dt(),N.markersarea.empty();for(var t=0;t<h.length;t++){var e=h[t],o=$("<div></div>").appendTo(N.markersarea);o.addClass("color-stop").css("left",e.position+e.unit).data(e),(n=o).on("touchstart mousedown",function(t){1<t.which||(ft((k=$(this)).data("index")),ut(),t.stopPropagation(),t.preventDefault())}),n.on("click",function(t){t.stopPropagation(),t.preventDefault()});var i=$("<div></div>"),n=$("<span></span>");i.html(n),o.html(i),n.css("background-color",K(e))}zt()}}function zt(){$(".color-stop",N.markersarea).each(function(){var t=$(this),e="%"===t.data("unit")?100:t.parents(".css-gradient-editor-stoppointmarkers").width();t.data("position")>e?(t.addClass("overflow"),t.removeClass("underflow")):(t.data("position")<0?t.addClass("underflow"):t.removeClass("underflow"),t.removeClass("overflow"))})}function Ct(i){a!==r&&(void 0===i&&(i=!1),$(".css-gradient-editor-stoppointdata",N.colorstopslist).each(function(){for(var t=$(this),e=0;e<h.length;e++){var o=h[e];o.index===t.data("index")&&($("input.css-gradient-editor-stop-point-position",t).val(Number(o.position).toFixed(X.positiondecimals)),i&&$("input.css-gradient-editor-stop-point-color",t).trigger("colorpickersliders.updateColor",o.color))}}))}function St(t,e){e=void 0===e?s.data(t):e.data[t];return void 0===e&&console.log("missing preference: "+t),e}function Mt(t,e){void 0===s.data(t)&&console.log("Uninitialized preference: "+t),s.data(t,e)}function jt(){var t,e=$.extend({},s.data()),o=[],i=[];for(t in"linear"===e.gradient_type?(delete e.gradient_size,delete e.gradient_size_unit,delete e.gradient_size_value,delete e.gradient_size_major_unit,delete e.gradient_size_major_value,delete e.gradient_shape,delete e.gradient_position_vertical,delete e.gradient_position_vertical_unit,delete e.gradient_position_vertical_value,delete e.gradient_position_horizontal,delete e.gradient_position_horizontal_unit,delete e.gradient_position_horizontal_value,"angle"!==e.gradient_direction&&delete e.linear_gradient_angle):"radial"===e.gradient_type&&(delete e.gradient_direction,delete e.linear_gradient_angle,"ellipse"===e.gradient_shape&&"explicit"===e.gradient_size||(delete e.gradient_size_major_unit,delete e.gradient_size_major_value),"explicit"!==e.gradient_size&&(delete e.gradient_size_unit,delete e.gradient_size_value),"explicit"!==e.gradient_position_horizontal&&(delete e.gradient_position_horizontal_unit,delete e.gradient_position_horizontal_value),"explicit"!==e.gradient_position_vertical&&(delete e.gradient_position_vertical_unit,delete e.gradient_position_vertical_value)),e)e.hasOwnProperty(t)&&o.push(Y[t]+"="+encodeURIComponent(e[t]));for(var n=Ht(),a=0;a<n.length;a++){var r=tinycolor(K(n[a])),r=r.getAlpha()<1?r.toHex8():r.toHex();i.push(encodeURIComponent(r)+"_"+encodeURIComponent(Math.round(10*n[a].position)/10)+"_"+encodeURIComponent(n[a].unit))}return o.join("&")+"&sp="+i.join("__")}function Pt(){o=jt(),N.permalink.attr("href",window.location.pathname+"?"+o).data("querystring",o),N.imagegradient.attr("href","gradient.php?"+o),"function"==typeof window.history.pushState&&window.history.replaceState({},"",window.location.pathname+"?"+o),ae(),clearTimeout(n),n=setTimeout(function(){var t="http://www.virtuosoft.eu/tools/css-gradient-generator/?"+N.permalink.data("querystring");try{e.makeCode(t)}catch(t){}},500)}function Dt(t){void 0===t&&(t=h),h.sort(function(t,e){return t.position-e.position})}function Rt(t){void 0===t&&(t=!0);var e=0,o=!1;$(".css-gradient-editor-stoppointdata input.css-gradient-editor-stop-point-position",N.colorstopslist).each(function(){var t=parseFloat($(this).val());t<e&&(o=!0),e=t}),o?(N.reorderstoppointsbutton.prop("disabled",!1),t&&($t(),ut())):N.reorderstoppointsbutton.prop("disabled",!0)}function It(t){var e=Ht(t);if(e.length<2)return!1;Dt(e);for(var o="",i=0;i<e.length;i++){var n=e[i];o+=","+K(n)+" "+Math.round(10*n.position)/10+n.unit}return o+=")"}function Tt(t){for(var e=Ot(t),o="",i=0;i<e.length;i++)o+=",color-stop("+Math.round(10*e[i].position)/1e3+", "+K(e[i])+")";return o}function Ot(t){var e=Ht(t);if(Dt(e),!(e.length<2)){var o=e[0].position,i=e[e.length-1].position,n=Math.max(i-o,1),a=0,r=0,s=St("gradient_repeat",t);"on"===s&&(a=-Math.ceil(o/n));var l,c=[],d=0;do{for(f=0;f<e.length;f++){var p=e[f].position;e[f].unit;p="%"!==e[f].unit?(l=p,Math.round(1e3*((l-o)/(i-o)))/1e3):Math.round(10*p)/10,r=p+=a*n,c[d++]={color:e[f].color,position:p}}}while(++a,"on"===s&&r<100);for(var g=0,u=c.length,f=0;f<c.length;f++)if(c[f].position<0)g=f;else if(100<c[f].position){u=f;break}return function(t){if(t.length<2)return;var e,o,i,n,a,r,s,l,c,d;t[0].position<0&&(e=t[0],i=(o=t[1]).position-e.position,n=1-o.position/i,a=tinycolor(e.color).toRgb(),s=(r=tinycolor(o.color).toRgb()).r-a.r,l=r.g-a.g,c=r.b-a.b,d={r:Math.round(a.r+n*s),g:Math.round(a.g+n*l),b:Math.round(a.b+n*c)},t[0].color=tinycolor(d).toRgbString(),t[0].position=0),100<t[t.length-1].position&&(e=t[t.length-1],o=t[t.length-2],i=Math.abs(o.position-e.position),n=1-(e.position-100)/i,a=tinycolor(e.color).toRgb(),s=(r=tinycolor(o.color).toRgb()).r-a.r,l=r.g-a.g,c=r.b-a.b,d={r:Math.round(a.r+n*s),g:Math.round(a.g+n*l),b:Math.round(a.b+n*c)},t[t.length-1].color=tinycolor(d).toRgbString(),t[t.length-1].position=100)}(c=c.splice(g,u-g+1)),c}}function At(t){for(var e,o=Ot(t),i="",n=0;n<o.length;n++)i+="<stop "+(e=o[n],'stop-color="'+(e=tinycolor(e.color)).toHexString()+'" stop-opacity="'+e.toRgb().a+'"')+' offset="'+o[n].position/100+'"/>';return i}function Ht(t){var e=Kt(t),o=0,i=[];Dt(e);for(var n=0;n<e.length;n++)e[n].markForDeath||(i[o++]=$.extend({},e[n]));return i}function Et(t){var e=St("gradient_direction",t),o="right";switch(St("gradient_type",t)){case"linear":if("angle"===e)var i=St("linear_gradient_angle",t),o=325<i||i<45?"top":i<135?"right":i<160?"bottom":"left";else switch(e){case"top":case"top left":case"top right":o="top";break;case"left":o="left";break;case"bottom":case"bottom left":case"bottom right":o="bottom";break;case"right":o="right"}break;case"radial":o="bottom"}return o}function Gt(t){t=Ht(t);if(t.length<2)return!1;var e,o,i=tinycolor(t[0].color).toHex8String(),n=tinycolor(t[t.length-1].color).toHex8String(),a=Et();switch(a){case"top":e=n,o=i,a="0";break;case"right":e=i,o=n,a="1";break;case"bottom":e=i,o=n,a="0";break;case"left":e=n,o=i,a="1"}return'progid:DXImageTransform.Microsoft.gradient(startColorstr="'+e+'",endColorstr="'+o+'",GradientType='+a+")"}function Ut(t,e){var o,t=void 0===e?(o=$('input[name="'+t+'"]').val(),$('input[name="'+t+'"]').next("span.input-group-addon.bootstrap-touchspin-postfix").html()):(o=e.data[t+"_value"],e.data[t+"_unit"]);return o+t}function Nt(t){switch(t){case"top":return"bottom";case"left":return"right";case"bottom":return"top";case"right":return"left";case"top left":return"bottom right";case"top right":return"bottom left";case"bottom left":return"top right";case"bottom right":return"top left"}}function Xt(t){var e,o,i=Math.round(50*Math.tan(t%45*Math.PI/180)),n=Math.sin(4*(t-45)*Math.PI/180),a=6*Math.sqrt(2),a=Math.abs(n*a);return 0<=t&&t<45&&(e=i+a,o=-50-a),45<=t&&t<90&&(e=50+a,o=-50+i-a),90<=t&&t<135&&(e=50+a,o=i+a),135<=t&&t<180&&(e=50-i+a,o=50+a),180<=t&&t<225&&(e=-i-a,o=50+a),225<=t&&t<270&&(e=-50-a,o=50-i+a),270<=t&&t<315&&(e=-50-a,o=-i-a),315<=t&&t<360&&(e=-50+i-a,o=-50-a),{xs:e,ys:o,x1:Math.round(10*(50-e))/10+"%",y1:Math.round(10*(50-o))/10+"%",x2:Math.round(10*(50+e))/10+"%",y2:Math.round(10*(50+o))/10+"%"}}function Yt(t,e){void 0===e&&(e="all");var o,i,n,a,r,s,l,c,d=St("gradient_direction",t),p="";return"on"===St("gradient_repeat",t)&&(p="repeating-"),"angle"===d?(c=St("linear_gradient_angle",t),"all"!==e&&"noprefix"!==e||(o=p+"linear-gradient("+c+"deg"+It(t)),"all"!==e&&"webkit"!==e||(i="-webkit-"+p+"linear-gradient("+Math.abs(c-450)%360+"deg"+It(t)),"all"!==e&&"ms"!==e||(n="-ms-"+p+"linear-gradient("+Math.abs(c-450)%360+"deg"+It(t))):("all"!==e&&"noprefix"!==e||(o=p+"linear-gradient(to "+d+It(t)),"all"!==e&&"webkit"!==e||(i="-webkit-"+p+"linear-gradient("+Nt(d)+It(t)),"all"!==e&&"ms"!==e||(n="-ms-"+p+"linear-gradient("+Nt(d)+It(t))),{valid:!0,noprefix:o,webkit:i,ms:n,oldwebkit:a="all"===e||"oldwebkit"===e?function(t,e){var o="-webkit-gradient(linear, ",i=Tt(t);if("angle"===e){t=Xt(St("linear_gradient_angle",t));o+=t.x1+" "+t.y1+", "+t.x2+" "+t.y2}else switch(e){case"top":o+="0% 100%, 0% 0%";break;case"top left":o+="100% 100%, 0% 0%";break;case"top right":o+="0% 100%, 100% 0%";break;case"left":o+="100% 0%, 0% 0%";break;case"bottom":o+="0% 0%, 0% 100%";break;case"bottom left":o+="100% 0%, 0% 100%";break;case"bottom right":o+="0% 0%, 100% 100%";break;case"right":o+="0% 0%, 100% 0%"}return o+=i+")"}(t,d):a,svg:r="all"===e||"svg"===e?function(t,e){var o=At(t),i="100%";if("angle"===e)var n=(t=Xt(St("linear_gradient_angle",t))).x1,a=t.y1,r=t.x2,s=t.y2;else switch(e){case"top":a=i,s=r=n="0%";break;case"top left":a=n="100%",s=r="0%";break;case"top right":r=a="100%",s=n="0%";break;case"left":n=i,s=r=a="0%";break;case"bottom":r=a=n="0%",s=i;break;case"bottom left":r=a="0%",s=n="100%";break;case"bottom right":a=n="0%",s=r="100%";break;case"right":r=i,s=a=n="0%"}return e='<svg xmlns="http://www.w3.org/2000/svg" width="100%" height="100%" viewBox="0 0 1 1" preserveAspectRatio="none"><linearGradient id="vsgg" gradientUnits="userSpaceOnUse" x1="'+n+'" y1="'+a+'" x2="'+r+'" y2="'+s+'">',e+=o,e+='</linearGradient><rect x="0" y="0" width="1" height="1" fill="url(#vsgg)" /></svg>',"url(data:image/svg+xml;base64,"+$.base64.encode(e)+")"}(t,d):r,filter:s="all"===e||"filter"===e?Gt(t):s,averagebgcolor:l="all"===e||"averagebgcolor"===e?ee(t):l}}function Ft(){var t=le("config_fallbackwidth");return t?parseInt(t):N.preview.width()}function qt(){var t=le("config_fallbackheight");return t?parseInt(t):N.preview.height()}function Jt(t,e,o){switch("left"===t?t=0:"center"===t?t=50:"right"===t&&(t=100),"top"===e?e=0:"center"===e?e=50:"bottom"===e&&(e=100),t=parseInt(t),e=parseInt(e),St("gradient_size",o)){case"closest-side":return i=t<50?t:100-t,n=e<50?e:100-e,Math.min(i,n);case"closest-corner":return i=t<50?t:100-t,n=e<50?e:100-e,Math.sqrt(i*i+n*n);case"farthest-side":return i=t<50?100:t,n=e<50?100-e:e,Math.max(i,n);case"farthest-corner":return i=t<50?100:t,n=e<50?100-e:e,Math.sqrt(i*i+n*n);default:var i=50<t?t:100-t,n=50<e?e:100-e;return"%"===St("gradient_size_unit",o)?"circle"===St("gradient_shape",o)?St("gradient_size_value",o):(parseInt(St("gradient_size_value",o))+parseInt(St("gradient_size_major_value")))/2:"circle"===St("gradient_shape",o)?Math.round(parseInt(St("gradient_size_value",o))/((Ft()+qt())/2)*1e3)/10:(n=(parseInt(St("gradient_size_value",o))+parseInt(St("gradient_size_major_value")))/2,Math.round(n/((Ft()+qt())/2)*1e3)/10)}}function Lt(t,e){void 0===e&&(e="all");var o,i,n,a,r,s,l,c,d,p,g=St("gradient_shape",t),u=St("gradient_size",t),f=g+" "+u,h=St("gradient_position_horizontal",t),v=St("gradient_position_vertical",t),_="";return"explicit"===h&&(h=Ut("gradient_position_horizontal",t)),"explicit"===v&&(v=Ut("gradient_position_vertical",t)),"explicit"===u&&(u=Ut("gradient_size",t),f="ellipse"===g?u=u+" "+Ut("gradient_size_major",t):u+" "+u),"on"===St("gradient_repeat",t)&&(_="repeating-"),"all"!==e&&"noprefix"!==e||(o=_+"radial-gradient("+g+" "+u+" at "+h+" "+v+It(t)),"all"!==e&&"webkit"!==e||(i="-webkit-"+_+"radial-gradient("+h+" "+v+", "+f+It(t)),"all"!==e&&"ms"!==e||(n="-ms-"+_+"radial-gradient("+h+" "+v+", "+f+It(t)),"all"!==e&&"svg"!==e||(a=function(t){var e,o,i=At(t),n=St("gradient_position_horizontal",t);switch(n){case"explicit":n=St("gradient_position_horizontal_value",t);break;case"left":n=0;break;case"center":n=50;break;case"right":n=100}switch(o=St("gradient_position_vertical",t)){case"explicit":o=St("gradient_position_vertical_value",t);break;case"top":o=0;break;case"center":o=50;break;case"bottom":o=100}return e='<svg xmlns="http://www.w3.org/2000/svg" width="100%" height="100%" viewBox="0 0 1 1" preserveAspectRatio="none"><radialGradient id="vsgg" gradientUnits="userSpaceOnUse" cx="'+n+'%" cy="'+o+'%" r="'+Jt(50<n?n:100-n,50<o?o:100-o,t)+'%">',e+=i,e+='</radialGradient><rect x="-50" y="-50" width="101" height="101" fill="url(#vsgg)" /></svg>',"url(data:image/svg+xml;base64,"+$.base64.encode(e)+")"}(t)),"all"!==e&&"filter"!==e||(r=Gt(t)),"all"!==e&&"averagebgcolor"!==e||(s=ee(t)),"all"!==e&&"oldwebkit"!==e||(c="-webkit-gradient(radial, ",d=Tt(l=t),p=St("gradient_size",l),_=St("gradient_position_horizontal",l),f=St("gradient_position_vertical",l),"explicit"===_&&(_=St("gradient_position_horizontal_value",l),"%"===St("gradient_position_horizontal_unit",l)&&(_+="%")),"explicit"===f&&(f=St("gradient_position_vertical_value",l),"%"===St("gradient_position_vertical_unit",l)&&(f+="%")),"explicit"!==p?(p=Jt(_,f,l),e=Ft(),t=qt(),p=Math.round(p/100*Math.sqrt(e*e+t*t))):(p=St("gradient_size_value",l),"ellipse"===St("gradient_shape",l)&&(p=Math.round((parseInt(p)+parseInt(St("gradient_size_major_value",l)))/2))),c+=_+" "+f+", 0, "+_+" "+f+", "+p,c=c+=d+")"),{valid:function(t,e,o,i){if("0"===e.charAt(0)||-1<e.indexOf(" 0"))return!1;var n=0;"0"===o.charAt(0)&&n++;"0"===i.charAt(0)&&n++;if(e.match(/(closest-corner)/i)&&o.match(/(left|right)/i)&&i.match(/(top|bottom)/i))return!1;if(e.match(/(closest-side)/i)&&(o.match(/(left|right)/i)||i.match(/(top|bottom)/i)))return!1;if("closest-side"===e&&0<n)return!1;if("closest-corner"===e&&1<n)return!1;if(t.match(/(ellipse)/i)&&e.match(/(closest-corner)/i)&&(0<n||o.match(/(left|right)/i)||i.match(/(top|bottom)/i)))return!1;return!0}(g,u,h,v),noprefix:o,oldwebkit:c,svg:a,webkit:i,ms:n,filter:r,averagebgcolor:s}}function Qt(){var t,e,o,i,n,a,r,s,l,c,d=Vt(),p=Ht(),g=le("config_cssselector");1<d?(l=("linear"===St("gradient_type")?Yt:Lt)()).valid?(t="    background-color: "+K(l.averagebgcolor)+";\n",e="    /* IE9, iOS 3.2+ */\n    background-image: "+l.svg+";\n",o="    background-image: "+l.oldwebkit+";\n",i="    /* Android 2.3- hack (needed for the actual radial gradient) */\n    background-image: "+l.svg+",\n        "+l.oldwebkit+";\n",n="    /* Android 2.3 */\n    background-image: "+l.webkit+";\n",a="    background-image: "+l.ms+";\n",r="    /* IE10+ */\n    background-image: "+l.noprefix+";\n",s="\n/* IE8- CSS hack */\n@media \\0screen\\,screen\\9 {\n    "+g+" {\n        filter: "+l.filter+";\n    }\n}",l="",le("config_generation_bgcolor")&&(l+=t),le("config_generation_svg")&&le("config_generation_oldwebkit")?"linear"===St("gradient_type",c)||"ellipse"!==St("gradient_shape",c)&&"explicit"===St("gradient_size",c)?(l+=e,l+=o):(l+=e,l+=i):(le("config_generation_svg")&&(l+=e),le("config_generation_oldwebkit")&&(l+=o)),le("config_generation_webkit")&&(l+=n),l+=r,le("config_generation_ms")&&(l+=a),O=g+" {\n"+l+"}\n",le("config_generation_iefilter")&&(O+=s)):O=0<d?g+" {\n    background-color: "+K(p[p.length-1])+";\n}":g+" {\n    background-color: transparent;\n}":1===d?(O=g+" {\n",O+="    background-color: "+K(p[0])+";\n",O+="}",tinycolor(p[0].color).getAlpha()<1&&(p='progid:DXImageTransform.Microsoft.gradient(startColorstr="'+tinycolor(p[0].color).toHex8String()+'",endColorstr="'+tinycolor(p[0].color).toHex8String()+'")',O+="\n\n/* IE8- CSS hack */\n@media \\0screen\\,screen\\9 {\n    "+g+" {\n        background-color:transparent;\n        filter: "+p+";\n    }\n}")):O=g+" {\n    background-color: transparent;\n}"}function Bt(){Qt(),N.cssoutput.val(O),N.cssoutput.data("output",O)}function Wt(t,e){void 0===t&&(t=N.preview);var o="transparent",i=Kt(e);Dt(i);for(var n=0;n<i.length;n++){var a=i[n];a.markForDeath||(o=K(a))}t?(t.css("background",o),t.is(N.preview)&&N.currentpreset.css("background",o)):(N.preview.css("background",o),N.currentpreset.css("background",o))}function Kt(t){return void 0===t?h:t.colorStops}function Vt(t){for(var e=Kt(t),o=0,i=0;i<e.length;i++)e[i].markForDeath||++o;return o}function Zt(t,e){if(void 0===t&&(t=N.preview),Vt(e)<2)Wt(t,e);else{var o=St("gradient_type",e);switch(o){case"linear":!function(t,e){void 0===t&&(t=N.preview);var o=Yt(e,q());!1!==o.stoppoints?(te(t,o,e),t.is(N.preview)&&te(N.currentpreset,o,e)):(Wt(t,e),Wt(N.currentpreset,e))}(t,e);break;case"radial":!function(t,e){void 0===t&&(t=N.preview);var o=Lt(e,q());o.valid&&!1!==o.stoppointsstring?(te(t,o,e),t.is(N.preview)&&te(N.currentpreset,o,e)):(Wt(t,e),Wt(N.currentpreset,e))}(t,e);break;default:console.log("Unknown gradient type: "+o)}}}function te(t,e,o){switch(void 0===t&&(t=N.preview),q()){case"noprefix":t.css("background-image",e.noprefix);break;case"webkit":t.css("background-image",e.webkit);break;case"ms":t.css("background-image",e.ms);break;case"svg":t.css("background-image",e.svg);break;case"oldwebkit":t.css("background-image",e.oldwebkit);break;case"filter":t.css("filter",e.filter);break;default:t.css("background-color",ee(o))}}function ee(t){var e=Ht(t);if(1===e.length)return e[0].color;for(var o=e[0].position,i=e[e.length-1].position,n=i-o,a=0,r=0,s=0,l=0,c=0;c<e.length;c++)100<i||"on"===St("gradient_repeat",t)?e[c].percentpos=(e[c].position-o)/n:e[c].percentpos=parseFloat(e[c].position)/100,e[c].rgb=tinycolor(e[c].color).toRgb();for(c=0;c<e.length;c++){var d=0<c?e[c-1].percentpos:0,p=c<e.length-1?e[c+1].percentpos:1;e[c].weight=(e[c].percentpos-d)/2+(p-e[c].percentpos)/2}for(e[0].weight+=e[0].percentpos/2,e[e.length-1].weight+=(1-e[e.length-1].percentpos)/2,c=0;c<e.length;c++)a+=e[c].rgb.r*e[c].weight,r+=e[c].rgb.g*e[c].weight,s+=e[c].rgb.b*e[c].weight,l+=e[c].rgb.a*e[c].weight;var g={r:a,g:r,b:s,a:l};return 1===g.a?tinycolor(g).toHexString():tinycolor(g).toRgbString()}function oe(){for(var t=0;t<X.defaultswatches.length;t++)T.push(ie(X.defaultswatches[t]))}function ie(t){var e=t.split("|");return 2===e.length&&(e[1]=V("%","%25",V("%25","%",e[1])),t=V(",","&",e[0])+"&sp=",t+=V("/","_",V(",","__",e[1]))),t=t.replace(/\+/g,"%20")}function ne(){if(!function(){var t;if(T=[],X.customswatchesnameprefix)try{if(t=JSON.parse(localStorage.getItem("gradientswatches-"+X.customswatchesnameprefix)))for(var e=0;e<t.length;e++)T.push(ie(t[e]));else oe()}catch(t){console.log(t),oe()}else oe()}(),N.swatches.html(""),T instanceof Array)for(var t=0;t<T.length;t++){var e=T[t],o=$("<span></span>"),i=$('<div class="btn btn-default css-gradient-editor-preset"></div>').data("gradient",e);i.append(o),N.swatches.append($("<li></li>").append(i)),Zt(o,tt(e))}ae()}function ae(){var e=!1;o=jt(),$(".css-gradient-editor-preset",N.swatches).filter(function(){var t;$(this).data("gradient")===o&&(e=!0,(t=$(this).parent()).is(N.actualswatch)||(N.actualswatch&&N.actualswatch.removeClass("actual"),(N.actualswatch=t).addClass("actual")))}),e||N.actualswatch&&(N.actualswatch.removeClass("actual"),N.actualswatch=!1),N.actualswatch?(N.swatches_add.prop("disabled",!0),N.swatches_remove.prop("disabled",!1)):(N.swatches_add.prop("disabled",!1),N.swatches_remove.prop("disabled",!0))}function re(){try{localStorage.setItem("gradientswatches-"+X.customswatchesnameprefix,JSON.stringify(T))}catch(t){}}function se(t,e){try{localStorage.setItem("userdata-"+t,JSON.stringify(e))}catch(t){}}function le(e){try{var t=JSON.parse(localStorage.getItem("userdata-"+e));return t=null===t||""===t?F[e]:t}catch(t){return F[e]}}function ce(t){var e=tt(t);(e||e.hasOwnProperty("colorStops"))&&(e=t,-1===T.indexOf(e)&&-1===T.indexOf(ie(e))&&(T.unshift(ie(t)),re(),$(document).trigger("cssgradienteditor.changeswatches")))}function de(){0<_?N.undobutton.prop("disabled",!1):N.undobutton.prop("disabled",!0),_<v.length-1?N.redobutton.prop("disabled",!1):N.redobutton.prop("disabled",!0)}function pe(){clearTimeout(m),A&&(Pt(),Bt(),H&&L(),-1<_&&o===v[_]||(v[++_]=o,v.length>_+1&&(v=v.slice(0,_+1)),de(),G&&se("lastGradient",o)))}rt(),function(){$("[title]").tooltip({animation:!1,html:!0}),E.css=$.fn.ColorPickerSliders.detectWhichGradientIsSupported(),$.fn.ColorPickerSliders.svgSupported()&&(E.svg=!0),window.location.search.length?et(window.location.search.substring(1)):le("lastGradient")?et(le("lastGradient")):et("t=linear,d=bottom,r=on|c5e3ef/0/%,4badd2/50/%,278fba/51/%,8ed4f1/100/%");$("[data-name^=config_]",s).each(function(){var t=$(this),e=t.data("name"),o=t.data("value"),i=le(e);void 0===t.data("value")&&t.data("config-toggle",!0),t.data("controlGroup")?i===o?t.is("input[type=text]")?t.val(i):(t.addClass("active"),void 0===t.data("value")&&t.data("value",!0)):void 0===t.data("value")&&t.data("value",!1):le(e)?t.is("input[type=text]")?t.val(i):(t.addClass("active"),void 0===t.data("value")&&t.data("value",!0)):void 0===t.data("value")&&t.data("value",!1)}),$("input[name=config-fallbackwidth]").on("change",function(){var t=$(this);se(t.data("name"),t.val())}),$("input[name=config-fallbackheight]").on("change",function(){var t=$(this);se(t.data("name"),t.val())}),$("input[name=config-cssselector]").on("change",function(){var t=$(this);se(t.data("name"),t.val())}),$(".modal-body").on("mousedown mouseup click contextmenu",function(t){t.stopPropagation()}),$("input[name=color_from], input[name=color_to]").on("contextmenu",function(t){t.stopPropagation()}),$(document).on("cssgradienteditor.changeswatches",function(){ne()}),$(document).scroll(function(){(new Date).getTime()-f>g?(f=(new Date).getTime(),at()):(clearTimeout(u),u=setTimeout(function(){f=(new Date).getTime(),at()},g))}),$(document).on("click",".force-layout-change",function(t){var e,o;t.preventDefault(),t.stopPropagation(),t=le("config_layout"),a<=t||("linear"===St("gradient_type")?"angle"===St("gradient_direction")&&Mt("gradient_direction",Et()):(Mt("gradient_shape","ellipse"),"explicit"===St("gradient_size")&&Mt("gradient_size","farthest-corner"),"explicit"===St("gradient_position_horizontal")&&Mt("gradient_position_horizontal","center"),"explicit"===St("gradient_position_vertical")&&Mt("gradient_position_vertical","center")),0===t&&(Mt("gradient_repeat","off"),Mt("gradient_type","linear"),Mt("gradient_direction",Et()),2<=(t=Ht()).length?(e=$.extend({},t[0]),o=$.extend({},t[t.length-1]),e.position=0,e.unit="%",o.position=100,o.unit="%"):1===t.length?(e=$.extend({},t[0]),o={position:100,unit:"%",color:w},e.position=0,e.unit="%"):(e={position:0,unit:"%",color:w},o={position:100,unit:"%",color:w}),wt(),_t(e),_t(o)),Q(),ot(),mt(),L())}),N.loaddefaults.on("click",function(){N.importtextarea.val(JSON.stringify(X.defaultswatches))}),N.layoutselectoreasy.on("click",function(t){se("config_layout",r),t.preventDefault(),t.stopPropagation(),L()}),N.layoutselectoradvanced.on("click",function(t){se("config_layout",l),t.preventDefault(),t.stopPropagation(),L()}),N.layoutselectorexpert.on("click",function(t){se("config_layout",c),t.preventDefault(),t.stopPropagation(),L()}),N.undobutton.on("click",function(){_<=0||(st(v[--_],!1),de())}),N.redobutton.on("click",function(){_+1>=v.length||(st(v[++_],!1),de())}),N.previewpopoutbutton.on("click",function(){nt()?(D=!1,N.previewpopoutbutton.removeClass("active"),N.previewarea.removeClass("preview-popout"),N.previewpopoutbutton.blur(),N.previewpopoutoverlaybutton.hide(),rt(),at()):(D=!0,N.previewpopoutbutton.addClass("active"),N.previewarea.addClass("preview-popout"),N.previewpopoutoverlaybutton.show(),rt()),("oldwebkit"===q()||"svg"===q()&&"explicit"===St("gradient_size")&&"%"!==St("gradient_size_unit"))&&mt()}),N.adjust_color.on("click",function(){(M?it:function(){var t;i=$('<div class="coloroffset-popover-container"></div>').appendTo("body"),(t=$('<div class="coloroffset-container"></div>').appendTo(i)).html($("#coloroffsethtml").html()),N.coloroffsethue=$(".offset-hue.slider-container .slider-controller",t),N.coloroffsetchroma=$(".offset-chroma.slider-container .slider-controller",t),N.coloroffsetlightness=$(".offset-lightness.slider-container .slider-controller",t),S=C=z=!1,N.coloroffsethue.css("left",50+U.hue/180*50+"%"),N.coloroffsetchroma.css("left",50+U.saturation/100*50+"%"),N.coloroffsetlightness.css("left",50+U.lightness/100*50+"%"),N.coloroffsethue.tooltip({title:"hue: "+(0<U.hue?"+":"")+U.hue,animation:!1,trigger:"manual"}),N.coloroffsetchroma.tooltip({title:"chroma: "+(0<U.saturation?"+":"")+U.saturation,animation:!1,trigger:"manual"}),N.coloroffsetlightness.tooltip({title:"lightness: "+(0<U.lightness?"+":"")+U.lightness,animation:!1,trigger:"manual"}),N.coloroffsethue.on("touchstart mousedown",function(t){1<t.which||(z=!0,t.stopPropagation(),t.preventDefault())}),N.coloroffsetchroma.on("touchstart mousedown",function(t){1<t.which||(C=!0,t.stopPropagation(),t.preventDefault())}),N.coloroffsetlightness.on("touchstart mousedown",function(t){1<t.which||(S=!0,t.stopPropagation(),t.preventDefault())}),N.coloroffsethue.on("mouseover",function(){z||C||S||N.coloroffsethue.tooltip("show")}),N.coloroffsethue.on("mouseout",function(){z||C||S||N.coloroffsethue.tooltip("hide")}),N.coloroffsetchroma.on("mouseover",function(){z||C||S||N.coloroffsetchroma.tooltip("show")}),N.coloroffsetchroma.on("mouseout",function(){z||C||S||N.coloroffsetchroma.tooltip("hide")}),N.coloroffsetlightness.on("mouseover",function(){z||C||S||N.coloroffsetlightness.tooltip("show")}),N.coloroffsetlightness.on("mouseout",function(){z||C||S||N.coloroffsetlightness.tooltip("hide")}),$(document).on("click",".coloroffset-close",function(){it()}),N.adjust_color.popover({html:!0,animation:!1,trigger:"manual",title:'Adjust gradient color <button type="button" class="close coloroffset-close pull-right" aria-hidden="true">×</button>',placement:"top",container:i,content:function(){return t}}),N.adjust_color.popover("show"),M=!0;var e=$(".popover"),o=$(window).width();o<e.offset().left+e.width()&&e.css("left",o-e.width()-5)})()}),N.resizehandler.on("mousedown touchstart",function(t){y=!0;var e=vt(t,N.previewarea);y={xoffset:N.previewarea.width()-e.horizontal.pixel,yoffset:N.previewarea.height()-e.vertical.pixel},t.stopPropagation(),t.preventDefault()}),N.markersarea.on("click",function(t){_t("%"===b?{position:vt(t,$(this)).horizontal.percent,unit:b,color:w}:{position:vt(t,$(this)).horizontal.pixel,unit:b,color:w}),t.stopPropagation(),t.preventDefault(),mt(),pe()}),$(document).on("touchmove mousemove",function(t){k&&(function(t){var e=N.markersarea.offset(),o=ht(t),t=!1;e=o.pageY>e.top?Math.abs(o.pageY-18-e.top):Math.abs(o.pageY+7-e.top);if(e>X.remove_distance){if(k.data("mark-for-death"))return;k.data("mark-for-death",1),k.hide(),t=!0}else{if(!k.data("mark-for-death"))return;k.data("mark-for-death",0),k.show(),t=!1}lt(k.data("index"),"markForDeath",t)}(t),function(t){var e=k.data("unit");t="%"===e?t.horizontal.percent:t.horizontal.pixel;t<d?t=d:p<t&&(t=p);k.css("left",t+e).data({position:t,unit:e}),lt(k.data("index"),"position",t),Zt(),Ct(),zt()}(vt(t,N.markersarea)),t.stopPropagation(),t.preventDefault())}),$(document).on("touchmove mousemove",function(t){y&&(function(t){var e=vt(t,N.previewarea),t=e.horizontal.pixel+y.xoffset,e=e.vertical.pixel+y.yoffset;nt()?(e<40&&(e=40),(t=t<50?50:t)>$(window).width()&&(t=$(window).width()),e>$(window).height()&&(e=$(window).height()),se("popoutpreviewwidth",t),se("popoutpreviewheight",e)):(e<30&&(e=30),(t=t<30?30:t)>N.previewcontainer.width()&&(t=N.previewcontainer.width()),400<e&&(e=400),se("previewwidth",t),se("previewheight",e));N.previewarea.css("width",t),N.previewarea.css("height",e),("oldwebkit"===q()||"svg"===q()&&"explicit"===St("gradient_size")&&"%"!==St("gradient_size_unit"))&&mt()}(t),t.stopPropagation(),t.preventDefault())}),$(document).on("touchend mouseup",function(t){k&&(k.data("mark-for-death")&&bt(k.data("index")),k=!1,pe(),Rt(),t.stopPropagation(),t.preventDefault()),R&&(R=!1,pe(),t.stopPropagation(),t.preventDefault()),y=y&&!1}),N.cssoutput.on("contextmenu",function(t){t.stopPropagation()}),N.permalink.on("contextmenu",function(t){t.stopPropagation()}),N.imagegradient.on("contextmenu",function(t){t.stopPropagation()}),s.on("contextmenu",function(t){return t.preventDefault(),!1}),$(".css-gradient-editor-controller",s).on("keydown mousedown touchstart",function(t){t.preventDefault(),t.stopPropagation(),function(t){var e=t.data("name"),o=t.data("value");if(0!==e.indexOf("config_")){if(St(e)===o)return;t.addClass("active"),Mt(e,o)}else if(t.data("control-group")){if(le(e)===o)return;t.addClass("active"),se(e,o)}else t.hasClass("active")?(se(e,!1),t.removeClass("active")):(se(e,!0),t.addClass("active"));$('.css-gradient-editor-controller.active[data-control-group="'+t.data("control-group")+'"]',s).removeClass("active").blur(),$('.css-gradient-editor-controller[data-control-group="'+t.data("control-group")+'"][data-name="'+e+'"][data-value="'+o+'"]',s).addClass("active"),Zt()}($(this))}),$(".css-gradient-editor-controller",s).on("click",function(t){t.preventDefault(),t.stopPropagation()}),N.anglecontroller.on("touchstart mousedown",function(t){R=!0,pt(t),gt(),Zt(),t.stopPropagation(),t.preventDefault()}),$(document).on("touchmove mousemove",function(t){R&&(pt(t),gt(),Zt())}),N.angleinput.on("keyup",function(){var t=$(this).val();if(!/^\d+$/.test(t=""===t?0:t))return $(this).val(St("linear_gradient_angle")),!1;Mt("linear_gradient_angle",t%360),gt(!1),Zt(),pe()}),N.angleinput.on("blur",function(){var t=$(this);""===t.val()?t.val("0"):t.val(St("linear_gradient_angle"))}),$(".css-gradient-editor-controller[data-name=gradient_type], .css-gradient-editor-controller[data-name=gradient_shape]",s).on("touchstart mousedown click",function(){dt(),pe()}),s.on("click",".input-group-addon.bootstrap-touchspin-postfix",function(){ct($(this)),Zt(),pe()}),$(".css-gradient-editor-radial-preferences input").on("change keyup",function(){Zt()}),N.addstoppointbutton.on("click",function(){_t({position:0,unit:b,color:w}),mt(),pe()}),N.reorderstoppointsbutton.on("click",function(){$t()}),$(".css-gradient-editor-stoppointlist",s).on("click",".bootstrap-touchspin-postfix",function(){var t=$(this),e=t.closest(".css-gradient-editor-stoppointdata"),o="%"===t.html()?"px":"%";b=o,"enabled"===le("config_mixedstoppointunits")?(t.html(o),e.data("unit",o),lt(t.closest(".css-gradient-editor-stoppointdata").data("index"),"unit",o)):($(".bootstrap-touchspin-postfix",N.colorstopslist).each(function(){var t=$(this);t.html(o),t.parents(".css-gradient-editor-stoppointdata").data("unit",o)}),lt(!1,"unit",o)),yt(),Zt(),pe()}),N.swatches.on("click","li .css-gradient-editor-preset",function(t){st($(this).data("gradient")),t.preventDefault()}),N.swatches_add.on("click",function(t){ce(o),t.preventDefault()}),N.swatches_remove.on("click",function(t){var e;-1!==(e=T.indexOf(o))&&(T.splice(e,1),re(),$(document).trigger("cssgradienteditor.changeswatches")),t.preventDefault()}),$(document).on("touchmove mousemove",function(t){var e;z&&(e=vt(t,N.coloroffsethue.parent()),N.coloroffsethue.css("left",e.horizontal.percent+"%"),U.hue=Math.round(3.6*e.horizontal.percent-180),N.coloroffsethue.tooltip("hide"),N.coloroffsethue.data("bs.tooltip").options.title="hue: "+(0<U.hue?"+":"")+U.hue,N.coloroffsethue.tooltip("show"),W(),Ct(!0),kt(),yt(),Zt(),t.stopPropagation(),t.preventDefault())}),$(document).on("touchmove mousemove",function(t){var e;C&&(e=vt(t,N.coloroffsetchroma.parent()),N.coloroffsetchroma.css("left",e.horizontal.percent+"%"),U.saturation=Math.round(2*e.horizontal.percent-100),N.coloroffsetchroma.tooltip("hide"),N.coloroffsetchroma.data("bs.tooltip").options.title="chroma: "+(0<U.saturation?"+":"")+U.saturation,N.coloroffsetchroma.tooltip("show"),W(),Ct(!0),kt(),yt(),Zt(),t.stopPropagation(),t.preventDefault())}),$(document).on("touchmove mousemove",function(t){var e;S&&(e=vt(t,N.coloroffsetlightness.parent()),N.coloroffsetlightness.css("left",e.horizontal.percent+"%"),U.lightness=Math.round(2*e.horizontal.percent-100),N.coloroffsetlightness.tooltip("hide"),N.coloroffsetlightness.data("bs.tooltip").options.title="lightness: "+(0<U.lightness?"+":"")+U.lightness,N.coloroffsetlightness.tooltip("show"),W(),Ct(!0),kt(),yt(),Zt(),t.stopPropagation(),t.preventDefault())}),$(document).on("touchend mouseup",function(){if(z||C||S){S=C=z=!1;try{N.coloroffsethue.tooltip("hide"),N.coloroffsetchroma.tooltip("hide"),N.coloroffsetlightness.tooltip("hide")}catch(t){}}pe()}),$(window).resize(function(){var t;!1!==j&&(t=$(window).height(),t=Math.round(t/3),j<t&&(t=j),N.previewarea.height(t))}),N.cssoutput.focus(function(){!function(t){{var e,o;t=t.get(0),void 0!==window.getSelection&&void 0!==document.createRange?((o=document.createRange()).selectNodeContents(t),(e=window.getSelection()).removeAllRanges(),e.addRange(o)):void 0!==document.selection&&void 0!==document.body.createTextRange&&((o=document.body.createTextRange()).moveToElementText(t),o.select())}}($(this))}),N.exportallmodal.on("show.bs.modal",function(){N.exportalltextarea.val(JSON.stringify(T).split('",').join('",\n'))}),N.importmodal.on("shown.bs.modal",function(){N.importtextarea.focus()}),N.importmodal.on("hide.bs.modal",function(){!function(t){try{var e=jQuery.parseJSON(t);if(!(e instanceof Array))return;for(var o=e.length,i=0;i<o;i++)ce(e[i])}catch(t){return console.log(t)}}(N.importtextarea.val())}),N.configmodal.on("hide.bs.modal",function(){mt()}),N.exportalltextarea.on("focus",function(){var e=$(this);e.select(),window.setTimeout(function(){e.select()},1),e.mouseup(function t(){return e.off("mouseup",t),!1})}),$(document).on("change",".bootstrap-touchspin input",function(){$(this).closest(".css-gradient-editor-controller").trigger("mousedown")}),$('input[name="angle"]').val(St("linear_gradient_angle")).TouchSpin({postfix:"<sup>o</sup>",min:0,max:359}).on("change touchspin.on.stopspin",function(t){Mt("linear_gradient_angle",$(this).val()%360),$(this).closest(".css-gradient-editor-controller").trigger("mousedown"),gt(!1),Zt(),"touchspin"===t.type&&pe()}),$('input[name="gradient_size"]').val(St("gradient_size_value")).TouchSpin({postfix:St("gradient_size_unit"),min:0,max:p}).on("change touchspin.on.stopspin",function(t){J($(this)),"touchspin"===t.type&&pe()}),$('input[name="gradient_size_major"]').val(St("gradient_size_major_value")).TouchSpin({postfix:St("gradient_size_major_unit"),min:0,max:p}).on("change touchspin.on.stopspin",function(t){J($(this)),"touchspin"===t.type&&pe()}),$('input[name="gradient_position_horizontal"]').val(St("gradient_position_horizontal_value")).TouchSpin({postfix:St("gradient_position_horizontal_unit"),min:d,max:p}).on("change touchspin.on.stopspin",function(t){J($(this)),"touchspin"===t.type&&pe()}),$('input[name="gradient_position_vertical"]').val(St("gradient_position_vertical_value")).TouchSpin({postfix:St("gradient_position_vertical_unit"),min:d,max:p}).on("change touchspin.on.stopspin",function(t){J($(this)),"touchspin"===t.type&&pe()}),dt(),ne(),mt(!0),N.preview.removeClass("ajax-loader"),e=new QRCode("permalinkqr",{text:"http://www.virtuosoft.eu/css-gradient-generator/",width:280,height:280,colorDark:"#000000",colorLight:"#ffffff",correctLevel:QRCode.CorrectLevel.H})}(),L(),v=[],_=-1,pe(),G=!0,de()};